﻿Imports System.Runtime.InteropServices
Imports System.ComponentModel
Imports System.Windows.Forms
Imports AddinExpress.MSO
Imports Excel = Microsoft.Office.Interop.Excel

'Add-in Express Add-in Module
<GuidAttribute("5D37B31A-72AB-4AB1-93DF-C1A461895F59"), ProgIdAttribute("adx_xl_vb_switchTaskPanes.AddinModule")> _
Public Class AddinModule
    Inherits AddinExpress.MSO.ADXAddinModule
    Friend WithEvents AdxExcelTaskPanesManager1 As AddinExpress.XL.ADXExcelTaskPanesManager
    Friend WithEvents AdxExcelTaskPanesCollectionItem1 As AddinExpress.XL.ADXExcelTaskPanesCollectionItem
    Friend WithEvents AdxExcelTaskPanesCollectionItem2 As AddinExpress.XL.ADXExcelTaskPanesCollectionItem
    Friend WithEvents AdxExcelTaskPanesCollectionItem3 As AddinExpress.XL.ADXExcelTaskPanesCollectionItem

#Region " Component Designer generated code. "
    'Required by designer
    Private components As System.ComponentModel.IContainer
 
    'Required by designer - do not modify
    'the following method
    Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Me.AdxExcelTaskPanesManager1 = New AddinExpress.XL.ADXExcelTaskPanesManager(Me.components)
        Me.AdxExcelTaskPanesCollectionItem1 = New AddinExpress.XL.ADXExcelTaskPanesCollectionItem(Me.components)
        Me.AdxExcelTaskPanesCollectionItem2 = New AddinExpress.XL.ADXExcelTaskPanesCollectionItem(Me.components)
        Me.AdxExcelTaskPanesCollectionItem3 = New AddinExpress.XL.ADXExcelTaskPanesCollectionItem(Me.components)
        '
        'AdxExcelTaskPanesManager1
        '
        Me.AdxExcelTaskPanesManager1.Items.Add(Me.AdxExcelTaskPanesCollectionItem1)
        Me.AdxExcelTaskPanesManager1.Items.Add(Me.AdxExcelTaskPanesCollectionItem2)
        Me.AdxExcelTaskPanesManager1.Items.Add(Me.AdxExcelTaskPanesCollectionItem3)
        Me.AdxExcelTaskPanesManager1.SetOwner(Me)
        '
        'AdxExcelTaskPanesCollectionItem1
        '
        Me.AdxExcelTaskPanesCollectionItem1.Position = AddinExpress.XL.ADXExcelTaskPanePosition.Bottom
        Me.AdxExcelTaskPanesCollectionItem1.TaskPaneClassName = "adx_xl_vb_switchTaskPanes.ControllingTaskPane"
        Me.AdxExcelTaskPanesCollectionItem1.UseOfficeThemeForBackground = True
        '
        'AdxExcelTaskPanesCollectionItem2
        '
        Me.AdxExcelTaskPanesCollectionItem2.Position = AddinExpress.XL.ADXExcelTaskPanePosition.Right
        Me.AdxExcelTaskPanesCollectionItem2.TaskPaneClassName = "adx_xl_vb_switchTaskPanes.ADXExcelTaskPane1"
        Me.AdxExcelTaskPanesCollectionItem2.UseOfficeThemeForBackground = True
        '
        'AdxExcelTaskPanesCollectionItem3
        '
        Me.AdxExcelTaskPanesCollectionItem3.Position = AddinExpress.XL.ADXExcelTaskPanePosition.Right
        Me.AdxExcelTaskPanesCollectionItem3.TaskPaneClassName = "adx_xl_vb_switchTaskPanes.ADXExcelTaskPane2"
        Me.AdxExcelTaskPanesCollectionItem3.UseOfficeThemeForBackground = True
        '
        'AddinModule
        '
        Me.AddinName = "adx_xl_vb_switchTaskPanes"
        Me.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaExcel

    End Sub
 
#End Region
 
#Region " Add-in Express automatic code "
 
    'Required by Add-in Express - do not modify
    'the methods within this region
 
    Public Overrides Function GetContainer() As System.ComponentModel.IContainer
        If components Is Nothing Then
            components = New System.ComponentModel.Container
        End If
        GetContainer = components
    End Function
 
    <ComRegisterFunctionAttribute()> _
    Public Shared Sub AddinRegister(ByVal t As Type)
        AddinExpress.MSO.ADXAddinModule.ADXRegister(t)
    End Sub
 
    <ComUnregisterFunctionAttribute()> _
    Public Shared Sub AddinUnregister(ByVal t As Type)
        AddinExpress.MSO.ADXAddinModule.ADXUnregister(t)
    End Sub
 
    Public Overrides Sub UninstallControls()
        MyBase.UninstallControls()
    End Sub
 
#End Region
 
    Public Sub New()
        MyBase.New()
 
        Application.EnableVisualStyles()
        'This call is required by the Component Designer
        InitializeComponent()
 
        'Please add any initialization code to the AddinInitialize event handler
 
    End Sub

    Public Shared Shadows ReadOnly Property CurrentInstance() As AddinModule
        Get
            Return CType(AddinExpress.MSO.ADXAddinModule.CurrentInstance, AddinModule)
        End Get
    End Property

    Public ReadOnly Property ExcelApp() As Excel._Application
        Get
            Return CType(HostApplication, Excel._Application)
        End Get
    End Property


    Private Sub AddinModule_AddinStartupComplete(sender As System.Object, e As System.EventArgs) Handles MyBase.AddinStartupComplete
        Dim ActiveTaskPane As AddinExpress.XL.ADXExcelTaskPane = GetVisibleAndActiveTaskPane()
        UpdateControllingForm(ActiveTaskPane)
    End Sub

    Private Function GetVisibleAndActiveTaskPane() As AddinExpress.XL.ADXExcelTaskPane

        Return GetVisibleAndActiveTaskPane(New AddinExpress.XL.ADXExcelTaskPanesCollectionItem() {adxExcelTaskPanesCollectionItem2, adxExcelTaskPanesCollectionItem3})
    End Function

    Private Function GetVisibleAndActiveTaskPane(ByVal Items As AddinExpress.XL.ADXExcelTaskPanesCollectionItem()) As AddinExpress.XL.ADXExcelTaskPane
        For i As Integer = 0 To Items.Length - 1
            Dim TaskPane As AddinExpress.XL.ADXExcelTaskPane = GetTaskPane(Items(i), True, True)
            If TaskPane IsNot Nothing Then
                Return TaskPane
            End If
        Next
        Return Nothing
    End Function

    Private Function GetTaskPane(ByVal Item As AddinExpress.XL.ADXExcelTaskPanesCollectionItem, ByVal ShouldBeVisible As Boolean, ByVal ShouldBeActive As Boolean) As AddinExpress.XL.ADXExcelTaskPane
        Dim TaskPane As AddinExpress.XL.ADXExcelTaskPane = Item.TaskPaneInstance
        If TaskPane IsNot Nothing Then
            If (ShouldBeVisible AndAlso TaskPane.Visible OrElse (Not ShouldBeVisible AndAlso Not TaskPane.Visible)) AndAlso (ShouldBeActive AndAlso TaskPane.Active OrElse (Not ShouldBeActive AndAlso Not TaskPane.Active)) Then
                Return TaskPane
            End If
        End If
        Return Nothing
    End Function

    Public Sub UpdateControllingForm(ByVal ActiveTaskPane As AddinExpress.XL.ADXExcelTaskPane)
        If AdxExcelTaskPanesCollectionItem1.TaskPaneInstance IsNot Nothing _
        And ActiveTaskPane IsNot Nothing Then
            TryCast(AdxExcelTaskPanesCollectionItem1.TaskPaneInstance, ControllingTaskPane).ApplyActiveTaskPane(ActiveTaskPane.[GetType]())
        End If
    End Sub

    Public Sub ActivateExcelTaskPane(ByVal number As Integer)
        If number = 1 Then
            ActivateTaskPane(AdxExcelTaskPanesCollectionItem2.TaskPaneInstance)
        Else
            ActivateTaskPane(AdxExcelTaskPanesCollectionItem3.TaskPaneInstance)
        End If
    End Sub

    Private Sub ActivateTaskPane(ByVal TaskPane As AddinExpress.XL.ADXExcelTaskPane)
        If TaskPane IsNot Nothing Then
            TaskPane.Activate()
        End If
    End Sub
End Class

